$!-----------------------------------------------------------------------------
$! STARTUP_SERVER.COM
$!
$! This procedure provides for the startup and execution of the HTTP server.
$! It is designed to support a single server process on a single node, single
$! server processes on separate nodes within a cluster, and multiple server
$! processes within a single node, and of course, a combination of the latter
$! two.  Modification is only necessary if any one server will be supporting
$! a service or services different to any other within a cluster or single
$! system.  If multiple nodes within a cluster provide the same service(s)
$! modification is not required.  For supporting multiple server processes on
$! the one system some modification is required.
$!
$! DO NOT MODIFY THIS PROCEDURE!
$! *****************************
$! Create a node/port specific version and modify that if required (see below).
$!
$! Copy this procedure into the same location as the site's STARTUP.COM,
$! with the destination name STARTUP_SERVER_nodename.COM for each node in the
$! cluster.  If a system will provide different services via multiple server
$! processes then copy using a name that also includes the identifying port
$! number of the process, i.e. STARTUP_SERVER_nodename_port.COM  (remember,
$! the identifying port number is the first in the service list).  Ensure the
$! HTTP$SERVER account has read and execute permission to any such procedures!
$!
$! The STARTUP.COM procedure, when executing on any one node, searches for
$! these files and executes them to create the detached server process.
$!
$! Parameters to be passed to the HTTPD executable may be delivered two ways.
$! First, by "hard-wiring" them into each procedure's 'HTTPD_PARAMETERS'
$! symbol below.  Second, by creating a logical beginning "HTTPD$" and then
$! continued with the procedure's name, i.e. "HTTPD$STARTUP_SERVER_node_port".
$! If the parameters are not hard-wired this logical will be translated with
$! each server startup and the value used as the executable's command line.
$! This system logical is best defined in the STARTUP_LOCAL.COM procedure.
$!
$! 01-NOV-1998  MGD  initial, v5.3
$!-----------------------------------------------------------------------------
$!
$!(modify this symbol to "hard-wire" the services, etc., required)
$ HTTPD_PARAMETERS = ""
$!
$!-----------------------------------------------------------------------------
$!
$! SET VERIFY
$ SET NOON
$ SS$_DUPLNAM = 148
$ PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ PROCEDURE_NAME = F$PARSE(PROCEDURE,,,"NAME")
$ LOGFILE = PROCEDURE_NAME - "STARTUP_SERVER_" - "STARTUP_SERVER"
$ IF LOGFILE .EQS. "" THEN LOGFILE = F$EDIT(F$GETSYI("NODENAME"),"COLLAPSE")
$ LOGFILE = "HT_SERVER_LOGS:" + LOGFILE + ".LOG"
$ IF F$MODE() .EQS. "BATCH" THEN GOTO MODE_BATCH
$ IF F$MODE() .EQS. "OTHER" THEN GOTO MODE_OTHER
$ EXIT
$!
$!-----------------------------------------------------------------------------
$ MODE_BATCH:
$!
$ PURGE /KEEP=3 'LOGFILE'
$ RUN SYS$SYSTEM:LOGINOUT /INPUT='PROCEDURE' /OUTPUT='LOGFILE' -
                          /DETACHED /AUTHORIZE
$ EXIT
$!
$!-----------------------------------------------------------------------------
$ MODE_OTHER:
$!
$ LOGICAL_NAME = "HTTPD$" + PROCEDURE_NAME
$ HTTPD = "$HTTPD$EXE"
$ ERROR_COUNT = 0
$!
$ HTTPD_LOOP:
$!
$    PARAMS = HTTPD_PARAMETERS
$    IF PARAMS .EQS. ""
$    THEN
$       LOGICAL_PARAMS = F$TRNLNM(LOGICAL_NAME)
$!      (ensure enough quotes for command-line substitution)
$       PARAMS = F$ELEMENT(0,"""",LOGICAL_PARAMS)
$       COUNT = 1
$       QUOTE_LOOP:
$          PART = F$ELEMENT(COUNT,"""",LOGICAL_PARAMS)
$          IF PART .EQS. """" THEN GOTO END_QUOTE_LOOP
$          PARAMS = PARAMS + """" + PART
$          COUNT = COUNT + 1
$          GOTO QUOTE_LOOP
$       END_QUOTE_LOOP:
$    ENDIF
$!
$    SET VERIFY
$ HTTPD /PRIORITY=4 'PARAMS'
$!   'F$VERIFY(0)
$!
$!   (non-error exit, must be a restart, loop immediately)
$    IF $STATUS THEN GOTO HTTPD_LOOP
$    IF $STATUS .EQ. SS$_DUPLNAM THEN EXIT
$!
$    ERROR_COUNT = ERROR_COUNT + 1
$    IF ERROR_COUNT .LT. 120
$       THEN WAIT 00:00:15
$       ELSE WAIT 00:15:00
$    ENDIF
$    GOTO HTTPD_LOOP
$!
$!END_HTTPD_LOOP:
$!
$ EXIT
$!-----------------------------------------------------------------------------

