/*****************************************************************************/
/*
                                 Admin.h
*/
/*****************************************************************************/

#ifndef ADMIN_H_LOADED
#define ADMIN_H_LOADED 1

#include "wasd.h"
#include "auth.h"

/**********/
/* macros */
/**********/

#define ADMIN_WATCH_CONNECT                0x01
#define ADMIN_WATCH_REQUEST                0x02
#define ADMIN_WATCH_REQUEST_BODY           0x04
#define ADMIN_WATCH_REQUEST_HEADER         0x08
#define ADMIN_WATCH_RESPONSE              0x010
#define ADMIN_WATCH_RESPONSE_BODY         0x020
#define ADMIN_WATCH_RESPONSE_HEADER       0x040
#define ADMIN_WATCH_MAPPING               0x080
#define ADMIN_WATCH_AUTH                 0x0100
#define ADMIN_WATCH_ERROR                0x0200
#define ADMIN_WATCH_NETWORK              0x0400
#define ADMIN_WATCH_NETWORK_OCTETS       0x0800
#define ADMIN_WATCH_TIMER               0x01000
#define ADMIN_WATCH_LOG                 0x02000
#define ADMIN_WATCH_SESOLA              0x04000
#define ADMIN_WATCH_CGI                 0x08000
#define ADMIN_WATCH_DCL                 0x10000
#define ADMIN_WATCH_DECNET             0x020000
#define ADMIN_WATCH_FILTER             0x040000
#define ADMIN_WATCH_PROXY              0x080000
#define ADMIN_WATCH_PROXY_REQU_HDR    0x0100000
#define ADMIN_WATCH_PROXY_REQU_BDY    0x0200000
#define ADMIN_WATCH_PROXY_RESP_HDR    0x0400000
#define ADMIN_WATCH_PROXY_RESP_BDY    0x0800000
#define ADMIN_WATCH_PROXY_CACHE      0x01000000
#define ADMIN_WATCH_PROXY_CACHE_MNT  0x02000000

/* size of body chunk */
#define ADMIN_WATCH_BODY_CHUNK 96

/***********************/
/* function prototypes */
/***********************/

AdminBegin (struct RequestStruct*, void*);
AdminControl (struct RequestStruct*, void*);
AdminControlSuccess (struct RequestStruct*, char*, char*);
AdminMenu (struct RequestStruct*, void*);
AdminReportServerStats (struct RequestStruct*, void*);
AdminWatchBegin (struct RequestStruct*, void*);
boolean AdminWatchCli (char*);
AdminWatchCliSettings ();
char* AdminWatchCategory (int);
AdminWatchData (char*, int);
AdminWatchDataDump (char*, int);
AdminWatchDataFormatted (char*, ...);
AdminWatchDummyReadAst (struct RequestStruct*);
AdminWatchEnd (struct RequestStruct*);
AdminWatchFilter (char*, char*, char*, char*, char*);
AdminWatchReport (struct RequestStruct*, void*);
AdminWatchRequestHeader (char*, int);
AdminWatchSetNumber (struct RequestStruct*);
AdminWatchThis (struct RequestStruct*, char*, int, int, char*, ...);

#endif /* ADMIN_H_LOADED */

/*****************************************************************************/
