/*****************************************************************************/
/*
                                  Menu.h
*/
/*****************************************************************************/

#ifndef MENU_H_LOADED
#define MENU_H_LOADED 1

#include "wasd.h"

/**************/
/* structures */
/**************/

struct MenuTaskStruct
{
   boolean  /* SYSUAF authenticated user has been checked to have access */
            AuthVmsUserHasAccess,
            /* */
            ParseInUse;

   int  /* */
        FileNameLength,
        /* used to count consecutive blank lines */
        MenuBlankLineCount,
        /* used to count consecutive non-blank lines */
        MenuLineCount,
        /* used to track current section number */
        MenuSectionNumber;

   unsigned char  /* pointer to heap storage of dynamic record buffer */
                  *MenuBufferPtr;

   char  /* */
         Description [256],
         /* sys$parse(), sys$search() storage */
         ExpandedFileName [256],
         /* */
         FileName [256],
         /* */
         ReadBuffer [256],
         /* sys$parse(), sys$search() storage */
         ResultantFileName [256];

   /* RMS structures */
   struct FAB  FileFab;
   struct RAB  FileRab;
   struct NAM  FileNam;
   struct XABDAT  FileXabDat;
   struct FAB  SearchFab;
   struct NAM  SearchNam;

   /* pointer to function, used for specifying the next task */
   void (*MenuAstFunctionPtr)(struct RequestStruct*);

   struct MenuTaskStruct  *MenuTaskPtr;

   /* pointer to function, used for specifying the next task */
   void (*NextTaskFunction)(struct RequestStruct*);
};

/***********************/
/* function prototypes */
/***********************/

MenuBegin (struct RequestStruct*, void*, void*, char*);
MenuBeginImplicitDescription (struct RequestStruct*);
MenuContents (struct RAB*);
MenuDescription (struct RequestStruct*, int);
MenuEnd (struct RequestStruct*);
MenuEndImplicitDescription (struct RequestStruct*);
MenuFileDescription (struct RequestStruct*, void*, char*);
MenuFileDescriptionNext (struct RequestStruct*);
MenuFileDescriptionOf (struct FAB*);
MenuFileDescriptionDone (struct RequestStruct*);
MenuItems (struct RequestStruct*);
MenuNextContents (struct RequestStruct*);
MenuTitle (struct RequestStruct*);
MenuSearchItem (struct RequestStruct*, void*, char*, char*, char*);

#endif /* MENU_H_LOADED */

/*****************************************************************************/
